import { GraphQLResult } from 'graphql';
import { MiddlewareInterface } from './middleware';
export interface Request {
    debugName?: string;
    query?: string;
    variables?: Object;
}
export interface NetworkInterface {
    _uri: string;
    _opts: RequestInit;
    _middlewares: MiddlewareInterface[];
    query(request: Request): Promise<GraphQLResult>;
    use(middlewares: MiddlewareInterface[]): any;
}
export interface RequestAndOptions {
    request: Request;
    options: RequestInit;
}
export declare function createNetworkInterface(uri: string, opts?: RequestInit): NetworkInterface;
